package com.ekexiu.portal.dao;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.util.List;

import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.orm.annotation.dao.DAO;
import org.jfw.apt.orm.annotation.dao.method.From;
import org.jfw.apt.orm.annotation.dao.method.OrderBy;
import org.jfw.apt.orm.annotation.dao.method.operator.Insert;
import org.jfw.apt.orm.annotation.dao.method.operator.SelectList;
import org.jfw.apt.orm.annotation.dao.method.operator.SelectOne;
import org.jfw.apt.orm.annotation.dao.method.operator.Update;
import org.jfw.apt.orm.annotation.dao.method.operator.UpdateWith;
import org.jfw.apt.orm.annotation.dao.param.Set;

import com.ekexiu.portal.po.Consult;

@DAO
public abstract class ConsultDao {
	@Insert
	public abstract int insert(Connection con, Consult consult) throws SQLException;
	
	@Update
	public abstract int update(Connection con, Consult consult) throws SQLException;
	
	@UpdateWith
	@From(Consult.class)
	public abstract int updateFinishTime(Connection con, String consultId, @Set String finishTime) throws SQLException;
	
	public int updateRevoveryTime(Connection con,String consultId) throws SQLException{
        int _m_1 = 1;
        String sql ="UPDATE CONSULT SET REVOVERY_TIME= TO_CHAR(NOW(),'YYYYMMDDHH24MISS') WHERE CONSULT_ID = ?";
        PreparedStatement ps = con.prepareStatement(sql);
        try{
            ps.setString(_m_1++,consultId);
            return ps.executeUpdate();
        }finally{
            try{ps.close();}catch(Exception _m_2){}
        }
    }
	
	@SelectOne
	@Nullable
	public abstract Consult query(Connection con, String consultId) throws SQLException;
	
	@SelectList
	@OrderBy(" ORDER BY CONSULT.CREATE_TIME DESC ")
	public abstract List<Consult> queryPro(Connection con, String professorId) throws SQLException;
	
	@SelectList
	@OrderBy(" ORDER BY CONSULT.CREATE_TIME DESC ")
	public abstract List<Consult> queryCon(Connection con, String consultantId) throws SQLException;
	
	
}
